#include <stdint.h>
#include <stddef.h>
#include <debugging.h>
#include <kernel/tty.h>
#include <kernel/gdt.h>
#include <debugging.h>

static void* memcpy(void* restrict dstptr, const void* restrict srcptr, size_t size) {
	unsigned char* dst = (unsigned char*) dstptr;
	const unsigned char* src = (const unsigned char*) srcptr;
	for (size_t i = 0; i < size; i++)
		dst[i] = src[i];
	return dstptr;
}

extern void jump_to_userspace();

void run_program(uint8_t* program, size_t length)
{
    uint8_t* userland_code = (uint8_t*) 0x00800000;
    memcpy(userland_code, program, length);

    jump_to_userspace();
}
